unit fdate; { Format Date, Copyright (c) 1993 by ZzSoft. }
{$I comdir}
interface

function day_str (day:byte; mode:byte):string;
function month_str (month:byte; mode:byte):string;
function year_str (year:word; mode:byte):string;
function century_str (century:byte; mode:byte):string;
function weekday_str (weekday:byte; mode:byte):string;
function season_str (month:byte; mode:byte):string;
function FormatDate (Format:string; Year,Month,Day:word):string;

implementation
uses Dos,ss;

function day_of_week (Year,Month,Day:word):byte;
{ define day of the week for specified date
  Result: 0=Su,1=Mo,2=Tu,3=We,4=Th,5=Fr,6=Sa }
var
  y,c,dw:integer;
begin
  if Month>=3 then dec(Month,2)
  else begin
    inc(Month,10);
    dec(Year);
  end;
  y:=Year mod 100;
  c:=Year div 100;
  dw:=(((26*Month-2) div 10)+Day+y+(y div 4)+(c div 4)-(2*c)) mod 7;
  if dw<0 then day_of_week:=dw+7 else day_of_week:=dw;
end;

function num_str (num:word; mode:byte):string;
{ returns num in string representation for specified mode

  mode is:
    0 -  ?
    1 -  ?
    2 -  ?
}
const
  d30:array[1..9] of string[7] =
    ('','','','','',
     '','ᥬ','쬨','');
  d31:array[1..9] of string[7] =
    (' ',' ',' ',' ',' ',
     ' ','ᥬ ','ᥬ ',' ');
  d20:array[1..9] of string[10] =
    ('','','','','',
     '','ᥬ','쬨','');
  d21:array[1..9] of string[10] =
    (' ',' ',' ',' ',' ',
     ' ','ᥬ ','ᥬ ',' ');
  d10:array[1..9] of string[11] =
    ('','','ਤ','ப','⨤',
     '⨤','ᥬ','쬨','ﭮ');
  d11:array[2..9] of string[12] =
    (' ','ਤ ','ப ','줥 ',
     '줥 ','ᥬ줥 ','ᥬ줥 ','ﭮ ');
  d00:array[1..9] of string[11] =
    ('','','ਭ','ୠ','⭠',
     '⭠','ᥬ','ᥬ','⭠');
  d01:array[1..9] of string[7] =
    ('','','','⢥','',
     '','ᥤ','','');
var
  n0,n1,n2,n3:byte;
  s:string[60];
begin
  s:='';
  num_str:='';
  n0:=num mod 10;
  n1:=num mod 100   div 10;
  n2:=num mod 1000  div 100;
  n3:=num mod 10000 div 1000;
  if n0+n1+n2+n3=0 then exit;
  if n3<>0 then if (n2+n1+n0)=0 then s:=s+d30[n3]+''
  else
    case n3 of
         1:s:=s+d31[n3]+' ';
      2..4:s:=s+d31[n3]+' ';
      5..9:s:=s+d31[n3]+' ';
    end;
  if n2<>0 then if (n1+n0)=0 then s:=s+d20[n2] else s:=s+d21[n2];
  if n1<>0 then if n0=0 then s:=s+d10[n1] else if n1<>1 then s:=s+d11[n1];
  if n0<>0 then if n1<>1 then s:=s+d01[n0] else s:=s+d00[n0];
  if (n0<>0) and (n1<>1) then
    case mode of
      0:case n0 of
          1,4,5,9:s:=s+'';
          2,6,7,8:s:=s+'';
                3:s:=s+'';
        end;
      1:if n0=3 then s:=s+'' else s:=s+'';
      2:if n0=3 then s:=s+'쥣' else s:=s+'';
    end
  else
    case mode of
      0:if n1=4 then s:=s+'' else s:=s+'';
      1:s:=s+'';
      2:s:=s+'';
    end;
  num_str:=s;
end;

function day_str (day:byte; mode:byte):string;
{ returns day of month in string format for specified mode }
begin
  day_str:='';
  if not (day in [1..31]) then exit;
  if mode=0 then mode:=2;
  case mode of
    1:day_str:=_str(day);
    2:day_str:=rjust(_str(day),'0',2);
    3:day_str:=_str(day)+'-';
    4:day_str:=_str(day)+'-';
    5:day_str:=_str(day)+'-';
    6:day_str:=num_str(day,0);
    7:day_str:=num_str(day,1);
    8:day_str:=num_str(day,2);
  end;
end;

function month_str (month:byte; mode:byte):string;
{ returns month in string format for specified mode }
const
  monr:array[1..12] of string[8] =
    ('ﭢ','䥢ࠫ','','५','','',
     '','','ᥭ','','','');
  mone:array[1..12] of string[9] =
    ('january','february','march','april','may','june',
     'july','august','september','october','november','december');
begin
  month_str:='';
  if not (month in [1..12]) then exit;
  if mode=0 then mode:=2;
  case mode of
    1:month_str:=_str(month);
    2:month_str:=rjust(_str(month),'0',2);
    3:month_str:=monr[month];
    4:if month in [3,8] then month_str:=monr[month]+''
      else month_str:=copy(monr[month],1,length(monr[month])-1)+'';
    5:if month in [3,8] then month_str:=monr[month]+''
      else month_str:=copy(monr[month],1,length(monr[month])-1)+'';
    6:month_str:=copy(monr[month],1,3);
    7:month_str:=mone[month];
    8:month_str:=copy(mone[month],1,3);
  end;
end;

function year_str (year:word; mode:byte):string;
{ returns year in string format for specified mode }
begin
  year_str:='';
  year:=year mod 10000;
  if year=0 then exit;
  if mode=0 then mode:=2;
  case mode of
    1:year_str:=_str(year mod 100);
    2:year_str:=rjust(_str(year mod 100),'0',2);
    3:year_str:=_str(year);
    4:year_str:=rjust(_str(year),'0',4);
    5:year_str:=_str(year mod 100)+'-';
    6:year_str:=_str(year)+'-';
    7:year_str:=_str(year mod 100)+'-';
    8:year_str:=_str(year)+'-';
    9:year_str:=num_str(year,0);
   10:year_str:=num_str(year,2);
  end;
end;

function century_str (century:byte; mode:byte):string;
{ returns century in string format for specified mode }
begin
  century_str:='';
  if century=0 then exit;
  if mode=0 then mode:=1;
  case mode of
    1:century_str:=_str(century);
    2:century_str:=_str(century)+'-';
    3:century_str:=_str(century)+'-';
    4:century_str:=_str(century)+'-';
    5:century_str:=num_str(century,0);
    6:century_str:=num_str(century,1);
    7:century_str:=num_str(century,2);
  end;
end;

function weekday_str (weekday:byte; mode:byte):string;
{ returns day of the week in string format for specified mode }
const
  wdr:array[0..6] of string[11] =
    ('ᥭ','쭨','୨','।',
     '⢥','⭨','㡡');
  wde:array[0..6] of string[9] =
    ('sunday','monday','tuesday','wednesday',
     'thursday','friday','saturday');
  wsr = '᪯⢯';
  wse = 'sunmontuewedthufrisat';
begin
  weekday_str:='';
  weekday:=weekday mod 7;
  if mode=0 then mode:=1;
  case mode of
    1:weekday_str:=wdr[weekday];
    2:weekday_str:=copy(wdr[weekday],1,5-(weekday div 4));
    3:weekday_str:=copy(wsr,weekday*3+1,3);
    4:weekday_str:=copy(wsr,weekday*3+1,2);
    5:weekday_str:=copy(wsr,weekday*3+1,1);
    6:weekday_str:=wde[weekday];
    7:weekday_str:=copy(wse,weekday*3+1,3);
    8:weekday_str:=copy(wse,weekday*3+1,2);
    9:weekday_str:=copy(wse,weekday*3+1,1);
  end;
end;

function season_str (month:byte; mode:byte):string;
{ returns season in string format for specified mode }
const
  ssr1:array[0..3] of string[5] = ('','᭠','','ᥭ');
  ssr2:array[0..3] of string[6] = ('','᭮','⮬','ᥭ');
  sse:array[0..3] of string[6] = ('winter','spring','summer','autumn');
begin
  season_str:='';
  if not (month in [1..12]) then exit;
  if month=12 then month:=0;
  if mode=0 then mode:=1;
  case mode of
    1:season_str:=ssr1[month div 3];
    2:season_str:=ssr2[month div 3];
    3:season_str:=sse[month div 3];
  end;
end;

function FormatDate (Format:string; Year,Month,Day:word):string;
{ format date string processing }
var
  WeekDay:word;

function date_macro (macro_no:word; params:string):string;
var
  p1,p3,i:byte;
  p2,p4:char;
  err:integer;
  s:string;
begin
  if macro_no=6 then
  begin
    date_macro:=
      '$DAY('+param_str(params,',',1)+','+param_str(params,',',2)+
      ')'+param_str(params,',',3)+'$MONTH('+param_str(params,',',4)+
      ','+param_str(params,',',5)+')'+param_str(params,',',6)+
      '$YEAR('+param_str(params,',',7)+','+param_str(params,',',8)+')';
    exit;
  end;
  del_space(params);
  p1:=_val(param_str(params,',',1),nil);
  s:=param_str(params,',',2);
  if s='' then p2:='L' else p2:=upcase(s[1]);
  p3:=_val(param_str(params,',',3),@err);
  if err<>0 then p4:=#0
  else begin
    s:=param_str(params,',',4);
    if s='' then p4:='R' else p4:=upcase(s[1]);
  end;
  case macro_no of
    0:s:=day_str(Day,p1);
    1:s:=month_str(Month,p1);
    2:s:=year_str(Year,p1);
    3:s:=century_str(((Year mod 10000) div 100)+1,p1);
    4:s:=weekday_str(WeekDay,p1);
    5:s:=season_str(Month,p1);
  end;
  case p2 of
    'L':;
    'F':if s<>'' then s[1]:=upcase(s[1]);
    'U':for i:=1 to length(s) do s[i]:=upcase(s[i]);
  end;
  case p4 of
    'L':s:=ljust(s,' ',p3);
    'R':s:=rjust(s,' ',p3);
    'C':s:=cjust(s,' ',p3);
  end;
  date_macro:=s;
end;

const
  MACRO_COUNT=7;
  macro:array[0..MACRO_COUNT-1] of string[9] =
    ('$DAY(','$MONTH(','$YEAR(','$CENTURY(','$WEEKDAY(','$SEASON(','$DATE(');
var
  y,m,d:word;
  p0,p1,p2,p3:integer;
  i:byte;
begin
  GetDate(y,m,d,WeekDay);
  if Year=0 then Year:=y;
  if Month=0 then Month:=m;
  if Day=0 then Day:=d;
  WeekDay:=day_of_week(Year,Month,Day);
  p0:=1;
  repeat
    p0:=pos_str('$',Format,p0);
    if p0=0 then break;
    i:=0;
    while (i<MACRO_COUNT) and (pos_str(macro[i],Format,p0)<>p0) do inc(i);
    if i=MACRO_COUNT then
    begin
      inc(p0);
      continue;
    end;
    p1:=p0+length(macro[i]);
    if macro[i][length(macro[i])]='(' then
    begin
      p2:=pos_str(')',Format,p1);
      if p2=0 then
      begin
        inc(p0);
        continue;
      end;
      p3:=p2+1;
    end else begin
      p2:=p1;
      p3:=p1;
    end;
    subst_str(Format,date_macro(i,copy(Format,p1,p2-p1)),p0,p3-p0);
  until FALSE;
  FormatDate:=Format;
end;

end.
